Index: lib/TWiki/Plugins/DefaultPlugin.pm
===================================================================
--- lib/TWiki/Plugins/DefaultPlugin.pm	(revision 1767)
+++ lib/TWiki/Plugins/DefaultPlugin.pm	(working copy)
@@ -55,16 +55,19 @@
 # =========================
 package TWiki::Plugins::DefaultPlugin;
 
+use TWiki::Func;
+
+use strict;
+
 # =========================
 use vars qw(
         $web $topic $user $installWeb $VERSION $pluginName
         $debug $doOldInclude $renderingWeb
     );
 
-$VERSION = '1.021';
+$VERSION = '1.030';
 $pluginName = 'DefaultPlugin';  # Name of this Plugin
 
-# =========================
 sub initPlugin
 {
     ( $topic, $web, $user, $installWeb ) = @_;
@@ -88,85 +91,37 @@
     return 1;
 }
 
-# =========================
-sub DISABLE_earlyInitPlugin
-{
-### Remove DISABLE_ for a plugin that requires early initialization, that is expects to have
-### initializeUserHandler called before initPlugin, giving the plugin a chance to set the user
-### See SessionPlugin for an example of this.
-    return 1;
-}
-
-
-# =========================
-sub DISABLE_initializeUserHandler
-{
-### my ( $loginName, $url, $pathInfo ) = @_;   # do not uncomment, use $_[0], $_[1]... instead
-
-    TWiki::Func::writeDebug( "- ${pluginName}::initializeUserHandler( $_[0], $_[1] )" ) if $debug;
-
-    # Allows a plugin to set the username based on cookies. Called by TWiki::initialize.
-    # Return the user name, or "guest" if not logged in.
-    # New hook in TWiki::Plugins $VERSION = '1.010'
-
-}
-
-# =========================
-sub DISABLE_registrationHandler
-{
-### my ( $web, $wikiName, $loginName ) = @_;   # do not uncomment, use $_[0], $_[1]... instead
-
-    TWiki::Func::writeDebug( "- ${pluginName}::registrationHandler( $_[0], $_[1] )" ) if $debug;
-
-    # Allows a plugin to set a cookie at time of user registration.
-    # Called by the register script.
-    # New hook in TWiki::Plugins $VERSION = '1.010'
-
-}
-
-# =========================
-sub DISABLE_beforeCommonTagsHandler
-{
-### my ( $text, $topic, $web ) = @_;   # do not uncomment, use $_[0], $_[1]... instead
-
-    TWiki::Func::writeDebug( "- ${pluginName}::beforeCommonTagsHandler( $_[2].$_[1] )" ) if $debug;
-
-    # Called at the beginning of TWiki::handleCommonTags (for cache Plugins use only)
-}
-
-# =========================
 sub commonTagsHandler
 {
 ### my ( $text, $topic, $web ) = @_;   # do not uncomment, use $_[0], $_[1]... instead
 
     TWiki::Func::writeDebug( "- ${pluginName}::commonTagsHandler( $_[2].$_[1] )" ) if $debug;
 
-    # This is the place to define customized tags and variables
-    # Called by TWiki::handleCommonTags, after %INCLUDE:"..."%
-
     # for compatibility for earlier TWiki versions:
+
+    ######################
+    # Old INCLUDE syntax
     if( $doOldInclude ) {
         # allow two level includes
-        $_[0] =~ s/%INCLUDE:"([^%\"]*?)"%/TWiki::handleIncludeFile( $1, $_[1], $_[2], "" )/geo;
-        $_[0] =~ s/%INCLUDE:"([^%\"]*?)"%/TWiki::handleIncludeFile( $1, $_[1], $_[2], "" )/geo;
+        $_[0] =~ s/%INCLUDE:"([^%\"]*?)"%/TWiki::_handleINCLUDE( TWiki::extractParameters( $1 ), $_[1], $_[2], "" )/geo;
+        $_[0] =~ s/%INCLUDE:"([^%\"]*?)"%/TWiki::_handleINCLUDE( TWiki::extractParameters( $1 ), $_[1], $_[2], "" )/geo;
     }
 
-    # do custom extension rule, like for example:
-    # $_[0] =~ s/%XYZ%/&handleXyz()/ge;
-    # $_[0] =~ s/%XYZ{(.*?)}%/&handleXyz($1)/ge;
-}
+    ######################
+    # Full attachment filename
+    # Process the filename suffixed to %ATTACHURLPATH%
+    # Required for migration purposes
+    my $pubUrlPath = TWiki::Func::getPubUrlPath();
+    my $attfexpr = TWiki::nativeUrlEncode( "$pubUrlPath/$_[2]/$_[1]" );
+    my $fnRE =  TWiki::Func::getRegularExpression( "filenameRegex" );
+    $_[0] =~ s!$attfexpr/($fnRE)!"$attfexpr/".&TWiki::nativeUrlEncode($1)!ge;
 
-# =========================
-sub DISABLE_afterCommonTagsHandler
-{
-### my ( $text, $topic, $web ) = @_;   # do not uncomment, use $_[0], $_[1]... instead
-
-    TWiki::Func::writeDebug( "- ${pluginName}::afterCommonTagsHandler( $_[2].$_[1] )" ) if $debug;
-
-    # Called at the end of TWiki::handleCommonTags (for cache Plugins use only)
+    ######################
+    # TOC handling
+    # SMELL: this should be in its own plugin
+    $_[0] =~ s/%TOC({([^}]*)})?%/&_handleTOC($2, @_)/ge;
 }
 
-# =========================
 sub startRenderingHandler
 {
 ### my ( $text, $web ) = @_;   # do not uncomment, use $_[0], $_[1] instead
@@ -178,7 +133,6 @@
     $renderingWeb = $_[1];
 }
 
-# =========================
 sub outsidePREHandler
 {
 ### my ( $text ) = @_;   # do not uncomment, use $_[0] instead
@@ -213,152 +167,154 @@
 #   $_[0] =~ s/<link>(.*?)<\/link>/&TWiki::internalLink("",$web,$1,$1,"",1)/geo;
 }
 
-# =========================
-sub DISABLE_insidePREHandler
-{
-### my ( $text ) = @_;   # do not uncomment, use $_[0] instead
+# Parameters:
+#    * $text          : the text of the current topic
+#    * $topic         : the topic we are in
+#    * $web           : the web we are in
+#    * $tocAttributes : "Topic" [web="Web"] [depth="N"]
+# Return value: $tableOfContents
+# Andrea Sterbini 22-08-00 / PTh 28 Feb 2001
+# Handles %<nop>TOC{...}% syntax.  Creates a table of contents using TWiki bulleted
+# list markup, linked to the section headings of a topic. A section heading is
+# entered in one of the following forms:
+#    * $headingPatternSp : \t++... spaces section heading
+#    * $headingPatternDa : ---++... dashes section heading
+#    * $headingPatternHt : &lt;h[1-6]> HTML section heading &lt;/h[1-6]>
+sub _handleTOC {
+    my $args = shift;
+    my %params = TWiki::Func::extractParameters( $args );
 
-    ##TWiki::Func::writeDebug( "- ${pluginName}::insidePREHandler( $web.$topic )" ) if $debug;
+    ##     $_[0]     $_[1]      $_[2]    $_[3]
+    ## my( $theText, $theTopic, $theWeb, $attributes ) = @_;
+    my $topicName = $_[1];
+    my $webName = $_[2];
 
-    # This handler is called by getRenderedVersion, once per line, before any changes,
-    # for lines inside <pre> and <verbatim> tags. 
-    # Use it to define customized rendering rules
+    # get the topic name attribute
+    my $topicname = $params{_DEFAULT}  || $_[1];
 
-    # do custom extension rule, like for example:
-    # $_[0] =~ s/old/new/go;
-}
+    # get the web name attribute
+    my $web = $params{web} || $_[2];
+    $web =~ s/\//\./g;
+    my $webPath = $web;
+    $webPath =~ s/\./\//g;
 
-# =========================
-sub DISABLE_endRenderingHandler
-{
-### my ( $text ) = @_;   # do not uncomment, use $_[0] instead
+    # get the depth limit attribute
+    my $depth = $params{depth} || 6;
 
-    TWiki::Func::writeDebug( "- ${pluginName}::endRenderingHandler( $web.$topic )" ) if $debug;
+    #get the title attribute
+    my $title = $params{title} || "";
+    $title = "\n<span class=\"twikiTocTitle\">$title</span>" if( $title );
 
-    # This handler is called by getRenderedVersion just after the line loop, that is,
-    # after almost all XHTML rendering of a topic. <nop> tags are removed after this.
+    my $result  = "";
+    my $line  = "";
+    my $level = "";
+    my @list  = ();
+my $debug = "";
+    if( "$web.$topicname" eq "$_[2].$_[1]" ) {
+        # use text from parameter
+        @list = split( /\n/, $_[0] );
 
-}
+    } else {
+        # read text from file
+        if ( ! TWiki::Func::topicExists( $web, $topicname ) ) {
+            return _inlineError( "TOC: Cannot find topic \"$web.$topicname\"" );
+        }
+        my $t = TWiki::Func::readWebTopic( $web, $topicname );
+        $t =~ s/.*?%STARTINCLUDE%//s;
+        $t =~ s/%STOPINCLUDE%.*//s;
+        @list = split( /\n/, TWiki::Func::expandCommonVariables( $t, $topicname, $web ) );
+    }
 
-# =========================
-sub DISABLE_beforeEditHandler
-{
-### my ( $text, $topic, $web ) = @_;   # do not uncomment, use $_[0], $_[1]... instead
+    my $headerDaRE =  TWiki::Func::getRegularExpression( "headerPatternDa" );
+    my $headerSpRE =  TWiki::Func::getRegularExpression( "headerPatternSp" );
+    my $headerHtRE =  TWiki::Func::getRegularExpression( "headerPatternHt" );
+    my $webnameRE =   TWiki::Func::getRegularExpression( "webNameRegex" );
+    my $wikiwordRE =  TWiki::Func::getRegularExpression( "wikiWordRegex" );
+    my $abbrevRE =    TWiki::Func::getRegularExpression( "abbrevRegex" );
+    my $headerNoTOC = TWiki::Func::getRegularExpression( "headerPatternNoTOC" );
+    @list = grep { /(<\/?pre>)|($headerDaRE)|($headerSpRE)|($headerHtRE)/o } @list;
+    my $insidePre = 0;
+    my $i = 0;
+    my $tabs = "";
+    my $anchor = "";
+    my $highest = 99;
+    # SMELL: this handling of <pre> is archaic. Surely this should be
+    # done using the outsidePreHandler?
+    foreach $line ( @list ) {
+        if( $line =~ /^.*<pre>.*$/io ) {
+            $insidePre = 1;
+            $line = "";
+        }
+        if( $line =~ /^.*<\/pre>.*$/io ) {
+            $insidePre = 0;
+            $line = "";
+        }
+        if (!$insidePre) {
+            $level = $line ;
+            if ( $line =~  /$headerDaRE/o ) {
+                $level =~ s/$headerDaRE/$1/go;
+                $level = length $level;
+                $line  =~ s/$headerDaRE/$2/go;
+            } elsif
+               ( $line =~  /$headerSpRE/o ) {
+                $level =~ s/$headerSpRE/$1/go;
+                $level = length $level;
+                $line  =~ s/$headerSpRE/$2/go;
+            } elsif
+               ( $line =~  /$headerHtRE/io ) {
+                $level =~ s/$headerHtRE/$1/gio;
+                $line  =~ s/$headerHtRE/$2/gio;
+            }
+            my $urlPath = "";
+            if( "$web.$topicname" ne "$webName.$topicName" ) {
+                # not current topic, can't omit URL
+                $urlPath = "$TWiki::dispScriptUrlPath$TWiki::dispViewPath$TWiki::scriptSuffix/$webPath/$topicname";
+            }
+            if( ( $line ) && ( $level <= $depth ) ) {
+                $anchor = TWiki::Render::makeAnchorName( $line );
+                # cut TOC exclude '---+ heading !! exclude'
+                $line  =~ s/\s*$headerNoTOC.+$//go;
+                $line  =~ s/[\n\r]//go;
+                next unless $line;
+                $highest = $level if( $level < $highest );
+                $tabs = "";
+                for( $i=0 ; $i<$level ; $i++ ) {
+                    $tabs = "\t$tabs";
+                }
+                # Remove *bold*, _italic_ and =fixed= formatting
+                $line =~ s/(^|[\s\(])\*([^\s]+?|[^\s].*?[^\s])\*($|[\s\,\.\;\:\!\?\)])/$1$2$3/g;
+                $line =~ s/(^|[\s\(])_+([^\s]+?|[^\s].*?[^\s])_+($|[\s\,\.\;\:\!\?\)])/$1$2$3/g;
+                $line =~ s/(^|[\s\(])=+([^\s]+?|[^\s].*?[^\s])=+($|[\s\,\.\;\:\!\?\)])/$1$2$3/g;
+                # Prevent WikiLinks
+                $line =~ s/\[\[.*?\]\[(.*?)\]\]/$1/g;  # '[[...][...]]'
+                $line =~ s/\[\[(.*?)\]\]/$1/ge;        # '[[...]]'
+                $line =~ s/([\s\(])($webnameRE)\.($wikiwordRE)/$1<nop>$3/g;  # 'Web.TopicName'
+                $line =~ s/([\s\(])($wikiwordRE)/$1<nop>$2/g;  # 'TopicName'
+                $line =~ s/([\s\(])($abbrevRE)/$1<nop>$2/g;    # 'TLA'
+                # create linked bullet item, using a relative link to anchor
+                $line = "$tabs* <a href=\"$urlPath#$anchor\">$line</a>";
+                $result .= "\n$line";
+            }
+        }
+    }
+    if( $result ) {
+        if( $highest > 1 ) {
+            # left shift TOC
+            $highest--;
+            $result =~ s/^\t{$highest}//gm;
+        }
+        $result = "<div class=\"twikiToc\">$title$result\n</div>";
+        return $result;
 
-    TWiki::Func::writeDebug( "- ${pluginName}::beforeEditHandler( $_[2].$_[1] )" ) if $debug;
-
-    # This handler is called by the edit script just before presenting the edit text
-    # in the edit box. Use it to process the text before editing.
-    # New hook in TWiki::Plugins $VERSION = '1.010'
-
+    } else {
+        return _inlineError("TOC: No TOC in \"$web.$topicname\" $debug");
+    }
 }
 
-# =========================
-sub DISABLE_afterEditHandler
-{
-### my ( $text, $topic, $web ) = @_;   # do not uncomment, use $_[0], $_[1]... instead
-
-    TWiki::Func::writeDebug( "- ${pluginName}::afterEditHandler( $_[2].$_[1] )" ) if $debug;
-
-    # This handler is called by the preview script just before presenting the text.
-    # New hook in TWiki::Plugins $VERSION = '1.010'
-
+# Format an error for inline inclusion in HTML
+sub _inlineError {
+    my( $errormessage ) = @_;
+    return "<font size=\"-1\" class=\"twikiAlert\" color=\"#FF0000\">$errormessage</font>" ;
 }
 
-# =========================
-sub DISABLE_beforeSaveHandler
-{
-### my ( $text, $topic, $web ) = @_;   # do not uncomment, use $_[0], $_[1]... instead
-
-    TWiki::Func::writeDebug( "- ${pluginName}::beforeSaveHandler( $_[2].$_[1] )" ) if $debug;
-
-    # This handler is called by TWiki::Store::saveTopic just before the save action.
-    # New hook in TWiki::Plugins $VERSION = '1.010'
-
-}
-
-# =========================
-sub DISABLE_afterSaveHandler
-{
-### my ( $text, $topic, $web, $error ) = @_;   # do not uncomment, use $_[0], $_[1]... instead
-
-    TWiki::Func::writeDebug( "- ${pluginName}::afterSaveHandler( $_[2].$_[1] )" ) if $debug;
-
-    # This handler is called by TWiki::Store::saveTopic just after the save action.
-    # New hook in TWiki::Plugins $VERSION = '1.020'
-
-}
-
-# =========================
-sub DISABLE_writeHeaderHandler
-{
-### my ( $query ) = @_;   # do not uncomment, use $_[0] instead
-
-    TWiki::Func::writeDebug( "- ${pluginName}::writeHeaderHandler( query )" ) if $debug;
-
-    # This handler is called by TWiki::writeHeader, just prior to writing header. 
-    # Return a single result: A string containing HTTP headers, delimited by CR/LF
-    # and with no blank lines. Plugin generated headers may be modified by core
-    # code before they are output, to fix bugs or manage caching. Plugins should no
-    # longer write headers to standard output.
-    # Use only in one Plugin.
-    # New hook in TWiki::Plugins $VERSION = '1.010'
-
-}
-
-# =========================
-sub DISABLE_redirectCgiQueryHandler
-{
-### my ( $query, $url ) = @_;   # do not uncomment, use $_[0], $_[1] instead
-
-    TWiki::Func::writeDebug( "- ${pluginName}::redirectCgiQueryHandler( query, $_[1] )" ) if $debug;
-
-    # This handler is called by TWiki::redirect. Use it to overload TWiki's internal redirect.
-    # Use only in one Plugin.
-    # New hook in TWiki::Plugins $VERSION = '1.010'
-
-}
-
-# =========================
-sub DISABLE_getSessionValueHandler
-{
-### my ( $key ) = @_;   # do not uncomment, use $_[0] instead
-
-    TWiki::Func::writeDebug( "- ${pluginName}::getSessionValueHandler( $_[0] )" ) if $debug;
-
-    # This handler is called by TWiki::getSessionValue. Return the value of a key.
-    # Use only in one Plugin.
-    # New hook in TWiki::Plugins $VERSION = '1.010'
-
-}
-
-# =========================
-sub DISABLE_setSessionValueHandler
-{
-### my ( $key, $value ) = @_;   # do not uncomment, use $_[0], $_[1] instead
-
-    TWiki::Func::writeDebug( "- ${pluginName}::setSessionValueHandler( $_[0], $_[1] )" ) if $debug;
-
-    # This handler is called by TWiki::setSessionValue. 
-    # Use only in one Plugin.
-    # New hook in TWiki::Plugins $VERSION = '1.010'
-
-}
-
-# =========================
-sub DISABLE_renderFormFieldForEditHandler
-{
-    my ( $name, $type, $size, $value, $attributes, $possibleValues ) = @_;
-
-    TWiki::Func::writeDebug( "- ${pluginName}::renderFormFieldForEditHandler( $web.$topic )" ) if $debug;
-
-    # This handler is called by Form.renderForEdit, before built in types are considered
-    
-    my $ret = "";
-    # Set ret to html, leave empty if plugin doesn't want to render this field
-    return $ret;
-}
-
-# =========================
-
 1;
Index: lib/TWiki/UI.pm
===================================================================
--- lib/TWiki/UI.pm	(revision 1767)
+++ lib/TWiki/UI.pm	(working copy)
@@ -54,13 +54,12 @@
   my $query = TWiki::getCgiQuery();
 
   if ( $query && $query->param( 'noredirect' )) {
-    TWiki::writeHeader( $query );
+      my $content = join(" ", @_) . " \n";
+      TWiki::writeHeader( $query, length( $content ) );
+      print $content;
   } elsif ( $query ) {
     TWiki::redirect( $query, $url );
-    return; # no print to STDOUT
   }
-
-  print join(" ", @_) . " \n";
 }
 
 =pod twiki
@@ -83,7 +82,7 @@
 
 =pod twiki
 
----+++ webExists( $web, $topic, $fn ) => boolean
+---+++ topicExists( $web, $topic, $fn ) => boolean
 Check if the given topic exists, returning 1 if it does, or
 invoking TWiki::UI::oops and returning 0 if it doesn't. $fn is
 the name of the command invoked, and will be used in composing
@@ -93,7 +92,7 @@
 
 sub topicExists {
   my ( $webName, $topic, $fn ) = @_;
-
+die "ARGH ", join(",",caller);
   return 1 if TWiki::Store::topicExists( $webName, $topic );
 
   oops( $webName, $topic, "${fn}notopic", "ERROR $webName.$topic Missing topic" );
@@ -126,8 +125,6 @@
   return 1;
 }
 
-=cut
-
 =pod twiki
 
 ---+++ isAccessPermitted( $web, $topic, $mode, $user ) => boolean
@@ -168,17 +165,28 @@
   return 0;
 }
 
-=pod twiki
+=pod
 
----+++ writeDebugTimes( $message )
-Write a debugging message indicating the time at which this function
-was called. Used for benchmarking.
+---++ sub readTemplateTopic (  $theTopicName  )
 
+Read a topic from the TWiki web, or if that fails from the current
+web.
+
 =cut
 
-sub writeDebugTimes {
-  my $mess = shift;
-  # TWiki::writeDebug();
+sub readTemplateTopic
+{
+    my( $theTopicName ) = @_;
+
+    $theTopicName =~ s/$TWiki::securityFilter//go;    # zap anything suspicious
+
+    # try to read in current web, if not read from TWiki web
+
+    my $web = $TWiki::twikiWebname;
+    if( TWiki::Store::topicExists( $TWiki::webName, $theTopicName ) ) {
+        $web = $TWiki::webName;
+    }
+    return TWiki::Store::readTopic( $web, $theTopicName );
 }
 
 1;
Index: lib/TWiki/User.pm
===================================================================
--- lib/TWiki/User.pm	(revision 1767)
+++ lib/TWiki/User.pm	(working copy)
@@ -33,17 +33,8 @@
 
 package TWiki::User;
 
-#use File::Copy;
-#use Time::Local;
+use TWiki::Templates;
 
-#if( $TWiki::OS eq "WINDOWS" ) {
-#    require MIME::Base64;
-#    import MIME::Base64 qw( encode_base64 );
-#    require Digest::SHA1;
-#    import Digest::SHA1 qw( sha1 );
-#}
-
-
 use strict;
 
 # 'Use locale' for internationalisation of Perl sorting in getTopicNames
@@ -51,27 +42,26 @@
 BEGIN {
     # Do a dynamic 'use locale' for this module
     if( $TWiki::useLocale ) {
-        require locale;
-	import locale ();
+        eval 'require locale; import locale ();';
     }
 }
 
-# FIXME: Move elsewhere?
-# template variable hash: (built from %TMPL:DEF{"key"}% ... %TMPL:END%)
-use vars qw( %templateVars $UserImpl ); # init in TWiki.pm so okay for modPerl
+use vars qw(
+            $UserImpl
+            %userToWikiList %wikiToUserList
+            $wikiNamesMapped
+           );
 
 $UserImpl = "";
 
-# ===========================
 =pod
 
 ---+++ initialize ()
 | Description: | loads the selected User Implementation |
 
 =cut
-sub initialize
-{
-    %templateVars = ();
+
+sub initialize {
 	if ( # (-e $TWiki::htpasswdFilename ) && #<<< maybe
 		( $TWiki::htpasswdFormatFamily eq "htpasswd" ) ) {
 	    $UserImpl = "TWiki::User::HtPasswdUser";
@@ -83,17 +73,7 @@
 	eval "use ".$UserImpl;
 }
 
-# ===========================
-=pod
-
----++ sub _getUserHandler (  $web, $topic, $attachment  )
-
-Not yet documented.
-
-=cut
-
-sub _getUserHandler
-{
+sub _getUserHandler {
    my( $web, $topic, $attachment ) = @_;
 
    $attachment = "" if( ! $attachment );
@@ -101,30 +81,29 @@
    my $handlerName = $UserImpl;
 
    my $handler = $handlerName->new( );
+   $wikiNamesMapped = 0;
+
    return $handler;
 }
 
-#========================= 
 =pod
 
 ---++ UserPasswordExists( $user ) ==> $passwordExists
 | Description: | checks to see if there is a $user in the password system |
 | Parameter: =$user= | the username we are looking for  |
 | Return: =$passwordExists= | "1" if true, "" if not |
-| TODO: | what if the login name is not the same as the twikiname?? (I think we don't have TWikiName to username mapping fully worked out|
+| TODO: | what if the login name is not the same as the twikiname?? (I think we dont have TWikiName to username mapping fully worked out|
 
 =cut
 
-sub UserPasswordExists
-{
+sub UserPasswordExists {
     my ( $user ) = @_;
 
     my $handler = _getUserHandler();
 
     return $handler->UserPasswordExists($user);
 }
- 
-#========================= 
+
 =pod
 
 ---++ UpdateUserPassword( $user, $oldUserPassword, $newUserPassword ) ==> $success
@@ -139,8 +118,7 @@
 
 =cut
 
-sub UpdateUserPassword
-{
+sub UpdateUserPassword {
     my ( $user, $oldUserPassword, $newUserPassword ) = @_;
 
 	if ( $user =~ /AnonymousContributor/ ) {
@@ -151,7 +129,6 @@
     return $handler->UpdateUserPassword($user, $oldUserPassword, $newUserPassword);
 }
 
-#========================= 
 =pod
 
 ---++ AddUserPassword( $user, $newUserPassword ) ==> $success
@@ -165,8 +142,7 @@
 
 =cut
 
-sub AddUserPassword
-{
+sub AddUserPassword {
     my ( $user, $newUserPassword ) = @_;
 
 	if ( $user =~ /AnonymousContributor/ ) {
@@ -177,7 +153,6 @@
     return $handler->AddUserPassword($user, $newUserPassword);
 }
 
-#========================= 
 =pod
 
 ---++ RemoveUser( $user ) ==> $success
@@ -188,15 +163,13 @@
 
 =cut
 
-sub RemoveUser
-{
+sub RemoveUser {
     my ( $user ) = @_;
 
     my $handler = _getUserHandler();
     return $handler->RemoveUser($user);
 }
 
-# =========================
 =pod
 
 ---++ CheckUserPasswd( $user, $password ) ==> $success
@@ -208,28 +181,25 @@
 
 =cut
 
-sub CheckUserPasswd
-{
+sub CheckUserPasswd {
     my ( $user, $password ) = @_;
 
     my $handler = _getUserHandler();
     return $handler->CheckUserPasswd($user, $password);
 }
- 
-# =========================
+
 =pod
 
 ---++ addUserToTWikiUsersTopic( $wikiName, $remoteUser ) ==> $topicName
-| Description: | create the User's TWikiTopic |
-| Parameter: =$wikiName= | the user's TWikiName |
+| Description: | create the Users TWikiTopic |
+| Parameter: =$wikiName= | the users TWikiName |
 | Parameter: =$remoteUser= | the remote username (is this used in the password file at any time?) |
 | Return: =$topicName= | the name of the TWikiTopic created |
 | TODO: | does this really belong here? |
 
 =cut
 
-sub addUserToTWikiUsersTopic
-{
+sub addUserToTWikiUsersTopic {
     my ( $wikiName, $remoteUser ) = @_;
     my $today = &TWiki::formatTime(time(), "\$day \$mon \$year", "gmtime");
     my $topicName = $TWiki::wikiUsersTopicname;
@@ -277,12 +247,191 @@
 
         $result .= "$line\n";
     }
-    &TWiki::Store::saveTopic( $TWiki::mainWebname, $topicName, $result, $meta, "", 1 );
+    TWiki::Store::saveTopic( $TWiki::mainWebname, $topicName, $result, $meta, "", 1 );
     return $topicName;
 }
 
+=pod
 
+---++ initializeRemoteUser( $remoteUser )
+Return value: $remoteUser
 
+Acts as a filter for $remoteUser.  If set, $remoteUser is filtered for
+insecure characters and untainted.
+
+If $doRememberRemoteUser and $remoteUser are both set in TWiki.cfg, it
+also caches $remoteUser as belonging to the IP address of the current request.
+
+If $doRememberRemoteUser is set and $remoteUser is not, then it sets
+$remoteUser to the last authenticated user to make a request with the
+current request's IP address, or $defaultUserName if no cached name
+is available.
+
+If neither are set, then it sets $remoteUser to $defaultUserName.
+
+SMELL: the association of a user with an IP address is a high
+risk strategy that can fail in the following environments:
+   1 Multiple users at the same IP address
+   1 Short-lease DHCP environments
+This is documented sufficiently for a risk assessment to be made
+by the installer. However it would be much safer (and more user
+friendly) to use cookies.
+
+SMELL: this should be done in User.pm
+
+=cut
+
+sub initializeRemoteUser {
+    my( $theRemoteUser ) = @_;
+
+    my $remoteUser = $theRemoteUser || $TWiki::defaultUserName;
+    $remoteUser =~ s/$TWiki::securityFilter//go;
+    $remoteUser =~ /(.*)/;
+    $remoteUser = $1;  # untaint variable
+
+    my $remoteAddr = $ENV{'REMOTE_ADDR'} || "";
+
+    if( $ENV{'REDIRECT_STATUS'} && $ENV{'REDIRECT_STATUS'} eq '401' ) {
+        # bail out if authentication failed
+        $remoteAddr = "";
+    }
+
+    if( ( ! $TWiki::doRememberRemoteUser ) || ( ! $remoteAddr ) ) {
+        # do not remember IP address
+        return $remoteUser;
+    }
+
+    my $text = TWiki::Store::readFile( $TWiki::remoteUserFilename );
+    # Assume no I18N characters in userids, as for email addresses
+    # FIXME: Needs fixing for IPv6?
+    my %AddrToName = map { split( /\|/, $_ ) }
+                     grep { /^[0-9\.]+\|[A-Za-z0-9]+\|$/ }
+                     split( /\n/, $text );
+
+    my $rememberedUser = "";
+    if( exists( $AddrToName{ $remoteAddr } ) ) {
+        $rememberedUser = $AddrToName{ $remoteAddr };
+    }
+
+    if( $theRemoteUser ) {
+        if( $theRemoteUser ne $rememberedUser ) {
+            $AddrToName{ $remoteAddr } = $theRemoteUser;
+            # create file as "$remoteAddr|$theRemoteUser|" lines
+            $text = "# This is a generated file, do not modify.\n";
+            foreach my $usrAddr ( sort keys %AddrToName ) {
+                my $usrName = $AddrToName{ $usrAddr };
+                # keep $userName unique
+                if(  ( $usrName ne $theRemoteUser )
+                  || ( $usrAddr eq $remoteAddr ) ) {
+                    $text .= "$usrAddr|$usrName|\n";
+                }
+            }
+            TWiki::Store::saveFile( $TWiki::remoteUserFilename, $text );
+        }
+    } else {
+        # get user name from AddrToName table
+        $remoteUser = $rememberedUser || $TWiki::defaultUserName;
+    }
+
+    return $remoteUser;
+}
+
+=pod
+
+---++ _cacheUserToWikiTranslations()
+Build hashes to translate in both directions between username (e.g. jsmith) 
+and WikiName (e.g. JaneSmith).  Only used for sites where authentication is
+managed by external Apache configuration, instead of via TWiki's .htpasswd
+mechanism.
+
+Should only be called once per request.
+
+SMELL: this should be done in User.pm
+
+=cut
+
+sub _cacheUserToWikiTranslations {
+    return if $wikiNamesMapped;
+    $wikiNamesMapped = 1;
+
+    %userToWikiList = ();
+    %wikiToUserList = ();
+    my @list = ();
+    if( $TWiki::doMapUserToWikiName ) {
+        @list = split( /\n/, TWiki::Store::readFile( $TWiki::userListFilename ) );
+    } else {
+        # fix for Codev.SecurityAlertGainAdminRightWithTWikiUsersMapping
+        # for .htpasswd authenticated sites ignore user list, but map only guest to TWikiGuest
+        @list = ( "\t* TWikiGuest - guest - " ); # CODE_SMELL on localization
+    }
+
+    # Get all entries with two '-' characters on same line, i.e.
+    # 'WikiName - userid - date created'
+    @list = grep { /^\s*\* $TWiki::regex{wikiWordRegex}\s*-\s*[^\-]*-/o } @list;
+    my $wUser;
+    my $lUser;
+    foreach( @list ) {
+	# Get the WikiName and userid, and build hashes in both directions
+        if(  ( /^\s*\* ($TWiki::regex{wikiWordRegex})\s*\-\s*([^\s]*).*/o ) && $2 ) {
+            $wUser = $1;	# WikiName
+            $lUser = $2;	# userid
+            $lUser =~ s/$TWiki::securityFilter//go;	# FIXME: Should filter in for security...
+            $userToWikiList{ $lUser } = $wUser;
+            $wikiToUserList{ $wUser } = $lUser;
+        }
+    }
+}
+
+=pod
+
+---++ userToWikiName( $loginUser, $dontAddWeb )
+Return value: $wikiName
+
+Translates intranet username (e.g. jsmith) to WikiName (e.g. JaneSmith)
+
+Unless $dontAddWeb is set, "Main." is prepended to the returned WikiName.
+
+If you give an invalid username, we just return that (no appending Main. blindy)
+
+SMELL: the userToWikiList cache should really contain the WebName so its possible 
+		to have userTopics in more than just the MainWeb (what if you move a user topic?)
+
+=cut
+
+sub userToWikiName {
+    my( $loginUser, $dontAddWeb ) = @_;
+
+    if( !$loginUser ) {
+        return "";
+    }
+
+    _cacheUserToWikiTranslations();
+
+    $loginUser =~ s/$TWiki::securityFilter//go;
+    my $wUser = $userToWikiList{ $loginUser } || $loginUser;
+    if( $dontAddWeb ) {
+        return $wUser;
+    }
+    return "$TWiki::mainWebname.$wUser";
+}
+
+=pod
+
+---++ wikiToUserName( $wikiName )
+Return value: $loginUser
+
+Translates WikiName (e.g. JaneSmith) to an intranet username (e.g. jsmith)
+
+=cut
+
+sub wikiToUserName {
+    my( $wikiUser ) = @_;
+    $wikiUser =~ s/^.*\.//g;
+    _cacheUserToWikiTranslations();
+    my $userName =  $wikiToUserList{"$wikiUser"} || $wikiUser;
+    return $userName;
+}
+
 1;
 
 # EOF
